local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

a.Rotations = {}
c.RegisterForEvents(a)
s.Spam[AddonName] = function()
	c.Flash(a)
end

local function monitorMending(info)
	if c.InfoMatches(info, "Prayer of Mending") then
		a.PrayerOfMendingTarget = info.Target
		c.Debug("Event", "Prayer of Mending target:", a.PrayerOfMendingTarget)
	end
end

a.Rotations.Discipline = {
	Spec = 1,
	OffSwitch = "disc_off",
	
	FlashInCombat = function()
		c.FlashAll(
			"Prayer of Mending",
			"Flash Heal under Surge of Light",
			"Shadowfiend for Mana",
			"Inner Focus",
			"Power Word: Shield",
			"Binding Heal",
			"Desperate Prayer")
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Power Word: Fortitude",
			"Shadow Protection",
			"Inner Fire unless Inner Will", 
			"Inner Will unless Inner Fire")
	end,
	
	CastSucceeded = monitorMending,
}

a.Rotations.Holy = {
	Spec = 2,
	OffSwitch = "holy_off",
	
	FlashInCombat = function()
		c.FlashAll(
			"Prayer of Mending",
			"Flash Heal under Surge of Light",
			"Shadowfiend for Mana",
			"Lightwell",
			"Greater Heal under Serendipity",
			"Prayer of Healing under Serendipity",
			"Binding Heal",
			"Holy Word: Chastise",
			"Holy Word: Serenity",
			"Holy Word: Sanctuary",
			"Desperate Prayer")
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Power Word: Fortitude",
			"Shadow Protection",
			"Inner Fire unless Inner Will", 
			"Inner Will unless Inner Fire",
			"Chakra")
	end,
	
	CastSucceeded = monitorMending,
}

a.Rotations.Shadow = {
	Spec = 3,
	OffSwitch = "shadow_off",
	
	FlashInCombat = function()
--c.Debug("Flash",
		c.PriorityFlash(
--			"Mind Flay to save Dark Evangelism",
--			"Mind Flay for SW:P",
			"Shadow Word: Pain",
			"Mind Blast for Empowered Shadow",
			"Mind Flay for Empowered Shadow",
			"Mind Blast at 3 Orbs",
			"Mind Flay for Dark Evangelism",
			"Vampiric Touch",
			"Devouring Plague",
			"Dark Archangel",
			"Mind Blast",
			"Shadow Word: Death",
			"Shadowfiend",
			"Mind Flay")
--)
	end,
	
	FlashOutOfCombat = function()
		c.PriorityFlash("Dispursion")
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Power Word: Fortitude",
			"Shadow Protection",
			"Shadowform", 
			"Inner Fire", 
			"Vampiric Embrace")
	end,
}
